SystemOrganization addCategory: #EitherTests!

TestCase subclass: #LeftTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EitherTests'!

!LeftTest methodsFor: 'testing - controlling' stamp: 'fbs 2/5/2012 22:04'!
testEitherOrCallsLeftBranchWithWrappedValue
	| leftCalled result rightCalled value |
	value := Object new.
	rightCalled := false.
	leftCalled := false.
	result := (Left value: value)
		either: [:r | rightCalled := true. Right value: r]
		or: [:l | leftCalled := true. Left value: l].
		
	self assert: leftCalled.
	self deny: rightCalled.
	self assert: (Left value: value) equals: result.! !

!LeftTest methodsFor: 'testing - controlling' stamp: 'fbs 12/21/2011 16:52'!
testIfLeftIfRightUsesLeftBlock
	self assert: #left equals: ((Left value: 1) ifLeft: [#left] ifRight: [#right])
! !

!LeftTest methodsFor: 'testing - controlling' stamp: 'fbs 12/21/2011 16:51'!
testIfRightIfLeftUsesLeftBlock
	self assert: #left equals: ((Left value: 1) ifRight: [#right] ifLeft: [#left])
! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:27'!
testLeftEqualsItself
	| left |
	left := Left value: 1.
	self assert: left = left.! !

!LeftTest methodsFor: 'testing - testing' stamp: 'fbs 7/1/2011 14:01'!
testLeftIsNotRight
	self deny: (Left value: 1) isRight! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:29'!
testLeftNotEqualToRight
	self deny: (Left value: 1) = (Right value: 1).! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:27'!
testLeftWithEqualValuesEqual
	self assert: (Left value: 1) = (Left value: 1).! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:28'!
testLeftWithUnequalValuesNotEqual
	self deny: (Left value: 1) = (Left value: 2).! !

!LeftTest methodsFor: 'testing - printing' stamp: 'fbs 7/6/2011 12:23'!
testPrintStringPrintsUsefully
	self assert: (Left value: 1) printString = 'Left 1'.
	self assert: (Left value: 'wrong') printString = 'Left ''wrong'''.! !

TestCase subclass: #RightTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EitherTests'!

!RightTest methodsFor: 'testing - controlling' stamp: 'fbs 2/5/2012 22:05'!
testEitherOrCallsRightBranchWithWrappedValue
	| leftCalled result rightCalled value |
	value := Object new.
	rightCalled := false.
	leftCalled := false.
	result := (Right value: value)
		either: [:r | rightCalled := true. Right value: r]
		or: [:l | leftCalled := true. Left value: l].
		
	self deny: leftCalled.
	self assert: rightCalled.
	self assert: (Right value: value) equals: result.! !

!RightTest methodsFor: 'testing - controlling' stamp: 'fbs 12/21/2011 16:52'!
testIfLeftIfRightUsesRightBlock
	self assert: #right equals: ((Right value: 1) ifLeft: [#left] ifRight: [#right])! !

!RightTest methodsFor: 'testing - controlling' stamp: 'fbs 12/21/2011 16:54'!
testIfRightIfLeftUsesRightBlock
	self assert: #right equals: ((Right value: 1) ifRight: [#right] ifLeft: [#left])! !

!RightTest methodsFor: 'testing - printing' stamp: 'fbs 7/6/2011 12:23'!
testPrintStringPrintsUsefully
	self assert: (Right value: 1) printString = 'Right 1'.
	self assert: (Right value: 'wrong') printString = 'Right ''wrong'''.! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:30'!
testRightEqualsItself
	| right |
	right := Left value: 1.
	self assert: right = right.! !

!RightTest methodsFor: 'testing - testing' stamp: 'fbs 7/1/2011 14:00'!
testRightIsRight
	self assert: (Right value: 1) isRight.! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:29'!
testRightNotEqualToLeft
	self deny: (Right value: 1) = (Left value: 1).! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:30'!
testRightWithEqualValuesEqual
	self assert: (Right value: 1) = (Right value: 1).! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:30'!
testRightWithUnequalValuesNotEqual
	self deny: (Right value: 1) = (Right value: 2).! !

MonadTestCase subclass: #EitherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EitherTests'!

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
f
	^ [:x | Right value: (x + 1)].! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
g
	^ [:x | Left value: x].! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
monad
	^ Either.! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
sampleBlock
	^ [:x | Right value: x]! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:17'!
sampleValues
	^ #(1 '2' #(3))! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 14:08'!
testBindToLeftReturnsLeft
	self deny: ((Left value: 1) >>= [:x | Right value: x]) isRight.
	self deny: ((Left value: 1) >>= [:x | Left value: x]) isRight.! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 14:08'!
testBindToRightReturnsDeeperValue
	self deny: ((Right value: 1) >>= [:x | Left value: x]) isRight.
	
	self assert: ((Right value: 1) >>= [:x | Right value: 2]) isRight.
	self assert: ((Right value: 1) >>= [:x | Right value: 2]) value = 2.! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 13:57'!
testReturnReturnsaRight
	self assert: (Either return: 1) isRight.! !
